From 2a93e6a8be6cd877f9a25a549e260ca6ac300a1d Mon Sep 17 00:00:00 2001
From: FateJH <Jason_DiDonato@yahoo.com>
Date: Tue, 1 Oct 2019 21:25:44 -0400
Subject: [PATCH 21/31] too much to itemize; still getting squads working, more
 or less

---
 .../scala/net/psforever/objects/Avatar.scala  |    9 +-
 .../psforever/objects/teamwork/Squad.scala    |   49 +-
 .../objects/teamwork/SquadFeatures.scala      |  154 +
 .../game/PlanetsideAttributeMessage.scala     |    5 +-
 .../game/SquadDefinitionActionMessage.scala   |    1 +
 .../scala/services/teamwork/SquadAction.scala |    5 +-
 .../services/teamwork/SquadResponse.scala     |    4 +-
 .../services/teamwork/SquadService.scala      | 3188 +++++++++++------
 .../teamwork/SquadServiceResponse.scala       |   11 +-
 .../src/main/scala/WorldSessionActor.scala    |  546 +--
 10 files changed, 2481 insertions(+), 1491 deletions(-)
 create mode 100644 common/src/main/scala/net/psforever/objects/teamwork/SquadFeatures.scala

diff --git a/common/src/main/scala/net/psforever/objects/Avatar.scala b/common/src/main/scala/net/psforever/objects/Avatar.scala
index 0416b6a9..4b689187 100644
--- a/common/src/main/scala/net/psforever/objects/Avatar.scala
+++ b/common/src/main/scala/net/psforever/objects/Avatar.scala
@@ -48,13 +48,8 @@ class Avatar(private val char_id : Long, val name : String, val faction : Planet
   private val deployables : DeployableToolbox = new DeployableToolbox
   /**
     * Looking For Squad:<br>
-    * Used to indicate both the marque that appears underneath a player's nameplate and an actual player state<br>
-    * This `Avatar`-specific "Looking for Squad" variable
-    * is used to indicate the active state of the LFS marque in the game
-    * and will change to `false` if the player is the member of a squad.
-    * A client-local version of "Looking for Squad" will maintain the real state of LFS
-    * once the player has joined a squad.
-    * The client-local version will restore the `Avatar`-local variable upon leaving the squad.
+    * Indicates both a player state and the text on the marquee under the player nameplate.
+    * Should only be valid when the player is not in a squad.
     */
   private var lfs : Boolean = false
 
diff --git a/common/src/main/scala/net/psforever/objects/teamwork/Squad.scala b/common/src/main/scala/net/psforever/objects/teamwork/Squad.scala
index 5f653dcd..3ff63035 100644
--- a/common/src/main/scala/net/psforever/objects/teamwork/Squad.scala
+++ b/common/src/main/scala/net/psforever/objects/teamwork/Squad.scala
@@ -11,11 +11,7 @@ class Squad(squadId : PlanetSideGUID, alignment : PlanetSideEmpire.Value) extend
   private var zoneId : Option[Int] = None
   private var task : String = ""
   private val membership : Array[Member] = Array.fill[Member](10)(new Member)
-  private val availability : Array[Boolean] = Array.fill[Boolean](10)(true)
-  private var listed : Boolean = false
-  private var leaderPositionIndex : Int = 0
-  private var autoApproveInvitationRequests : Boolean = false
-  private var locationFollowsSquadLead : Boolean = false
+  private val availability : Array[Boolean] = Array.fill[Boolean](10)(elem = true)
 
   override def GUID_=(d : PlanetSideGUID) : PlanetSideGUID = GUID
 
@@ -23,14 +19,7 @@ class Squad(squadId : PlanetSideGUID, alignment : PlanetSideEmpire.Value) extend
 
   def CustomZoneId : Boolean = zoneId.isDefined
 
-  def ZoneId : Int = zoneId.getOrElse({
-    membership.lift(leaderPositionIndex) match {
-      case Some(leader) =>
-        leader.ZoneId
-      case _ =>
-        0
-    }
-  })
+  def ZoneId : Int = zoneId.getOrElse(membership(0).ZoneId)
 
   def ZoneId_=(id : Int) : Int = {
     ZoneId_=(Some(id))
@@ -48,42 +37,12 @@ class Squad(squadId : PlanetSideGUID, alignment : PlanetSideEmpire.Value) extend
     Task
   }
 
-  def Listed : Boolean = listed
-
-  def Listed_=(announce : Boolean) : Boolean = {
-    listed = announce
-    Listed
-  }
-
-  def LocationFollowsSquadLead : Boolean = locationFollowsSquadLead
-
-  def LocationFollowsSquadLead_=(follow : Boolean) : Boolean = {
-    locationFollowsSquadLead = follow
-    LocationFollowsSquadLead
-  }
-
-  def AutoApproveInvitationRequests : Boolean = autoApproveInvitationRequests
-
-  def AutoApproveInvitationRequests_=(autoApprove : Boolean) : Boolean = {
-    autoApproveInvitationRequests = autoApprove
-    AutoApproveInvitationRequests
-  }
-
   def Membership : Array[Member] = membership
 
   def Availability : Array[Boolean] = availability
 
-  def LeaderPositionIndex : Int = leaderPositionIndex
-
-  def LeaderPositionIndex_=(position : Int) : Int = {
-    if(availability.lift(position).contains(true)) {
-      leaderPositionIndex = position
-    }
-    LeaderPositionIndex
-  }
-
   def Leader : Member = {
-    membership(leaderPositionIndex) match {
+    membership(0) match {
       case member if !member.Name.equals("") =>
         member
       case _ =>
@@ -102,9 +61,7 @@ object Squad {
     override def ZoneId_=(id : Int) : Int = 0
     override def ZoneId_=(id : Option[Int]) : Int = 0
     override def Task_=(assignment : String) : String =  ""
-    override def Listed_=(announce : Boolean) : Boolean = false
     override def Membership : Array[Member] = Array.empty[Member]
     override def Availability : Array[Boolean] = Array.fill[Boolean](10)(false)
-    override def LeaderPositionIndex_=(position : Int) : Int = 0
   }
 }
diff --git a/common/src/main/scala/net/psforever/objects/teamwork/SquadFeatures.scala b/common/src/main/scala/net/psforever/objects/teamwork/SquadFeatures.scala
new file mode 100644
index 00000000..a374f0ab
--- /dev/null
+++ b/common/src/main/scala/net/psforever/objects/teamwork/SquadFeatures.scala
@@ -0,0 +1,154 @@
+// Copyright (c) 2019 PSForever
+package net.psforever.objects.teamwork
+
+import akka.actor.{Actor, ActorContext, ActorRef, Cancellable, Props}
+import net.psforever.objects.DefaultCancellable
+import services.teamwork.SquadService.WaypointData
+import services.teamwork.SquadSwitchboard
+
+class SquadFeatures(val Squad : Squad) {
+  /**
+    * `initialAssociation` per squad is similar to "Does this squad want to recruit members?"
+    * The squad does not have to be flagged.
+    * Dispatches an `AssociateWithSquad` `SDAM` to the squad leader and ???
+    * and then a `SDDUM` that includes at least the squad owner name and char id.
+    * Dispatched only once when a squad is first listed
+    * or when the squad leader searches for recruits by proximity or for certain roles or by invite
+    * or when a spontaneous squad forms,
+    * whichever happens first.
+    * Additionally, the packets are also sent when the check is made when the continent is changed (or set).
+    */
+  private var initialAssociation : Boolean = true
+  /**
+    * na
+    */
+  private var switchboard : ActorRef = ActorRef.noSender
+  /**
+    * Waypoint data.
+    * The first four slots are used for squad waypoints.
+    * The fifth slot is used for the squad leader experience waypoint.<br>
+    * <br>
+    * All of the waypoints constantly exist as long as the squad to which they are attached exists.
+    * They are merely "activated" and "deactivated."
+    * When "activated," the waypoint knows on which continent to appear and where on the map and in the game world to be positioned.
+    * Waypoints manifest in the game world as a far-off beam of light that extends into the sky
+    * and whose ground contact utilizes a downwards pulsating arrow.
+    * On the continental map and deployment map, they appear as a diamond, with a differentiating number where applicable.
+    * The squad leader experience rally, for example, does not have a number like the preceding four waypoints.
+    * @see `Start`
+    */
+  private var waypoints : Array[WaypointData] = Array[WaypointData]()
+  /**
+    * The particular position being recruited right at the moment.
+    * When `None`. no highlighted searches have been indicated.
+    * When a positive integer or 0, indicates distributed `LookingForSquadRoleInvite` messages as recorded by `proxyInvites`.
+    * Only one position may bne actively recruited at a time in this case.
+    * When -1, indicates distributed `ProximityIvite` messages as recorded by `proxyInvites`.
+    * Previous efforts may or may not be forgotten if there is a switch between the two modes.
+    */
+  private var searchForRole : Option[Int] = None
+  /**
+    * Handle persistent data related to `ProximityInvite` and `LookingForSquadRoleInvite` messages
+    */
+  private var proxyInvites : List[Long] = Nil
+
+  private var requestInvitePrompt : Cancellable = DefaultCancellable.obj
+  /**
+    * These useres rejected invitation to this squad.
+    * For the purposes of wide-searches for membership
+    * such as Looking For Squad checks and proximity invitation,
+    * the unique character identifier numbers in this list are skipped.
+    * Direct invitation requests from the non sqad member should remain functional.
+    */
+  private var refusedPlayers : List[Long] = Nil
+  private var autoApproveInvitationRequests : Boolean = true
+  private var locationFollowsSquadLead : Boolean = true
+
+  private var listed : Boolean = false
+
+  private lazy val channel : String = s"${Squad.Faction}-Squad${Squad.GUID.guid}"
+
+  def Start(implicit context : ActorContext) : SquadFeatures = {
+    switchboard = context.actorOf(Props[SquadSwitchboard], s"squad${Squad.GUID.guid}")
+    waypoints = Array.fill[WaypointData](5)(new WaypointData())
+    this
+  }
+
+  def Stop : SquadFeatures = {
+    switchboard ! akka.actor.PoisonPill
+    switchboard = Actor.noSender
+    waypoints = Array.empty
+    requestInvitePrompt.cancel
+    this
+  }
+
+  def InitialAssociation : Boolean = initialAssociation
+
+  def InitialAssociation_=(assoc : Boolean) : Boolean = {
+    initialAssociation = assoc
+    InitialAssociation
+  }
+
+  def Switchboard : ActorRef = switchboard
+
+  def Waypoints : Array[WaypointData] = waypoints
+
+  def SearchForRole : Option[Int] = searchForRole
+
+  def SearchForRole_=(role : Int) : Option[Int] = SearchForRole_=(Some(role))
+
+  def SearchForRole_=(role : Option[Int]) : Option[Int] = {
+    searchForRole = role
+    SearchForRole
+  }
+
+  def ProxyInvites : List[Long] = proxyInvites
+
+  def ProxyInvites_=(list : List[Long]) : List[Long] = {
+    proxyInvites = list
+    ProxyInvites
+  }
+
+  def Refuse : List[Long] = refusedPlayers
+
+  def Refuse_=(charId : Long) : List[Long] = {
+    Refuse_=(List(charId))
+  }
+
+  def Refuse_=(list : List[Long]) : List[Long] = {
+    refusedPlayers = list ++ refusedPlayers
+    Refuse
+  }
+
+  def LocationFollowsSquadLead : Boolean = locationFollowsSquadLead
+
+  def LocationFollowsSquadLead_=(follow : Boolean) : Boolean = {
+    locationFollowsSquadLead = follow
+    LocationFollowsSquadLead
+  }
+
+  def AutoApproveInvitationRequests : Boolean = autoApproveInvitationRequests
+
+  def AutoApproveInvitationRequests_=(autoApprove : Boolean) : Boolean = {
+    autoApproveInvitationRequests = autoApprove
+    AutoApproveInvitationRequests
+  }
+
+  def Listed : Boolean = listed
+
+  def Listed_=(announce : Boolean) : Boolean = {
+    listed = announce
+    Listed
+  }
+
+  def ToChannel : String = channel
+
+  def Prompt : Cancellable = requestInvitePrompt
+
+  def Prompt_=(callback: Cancellable) : Cancellable = {
+    if(requestInvitePrompt.isCancelled) {
+      requestInvitePrompt = callback
+    }
+    Prompt
+  }
+}
\ No newline at end of file
diff --git a/common/src/main/scala/net/psforever/packet/game/PlanetsideAttributeMessage.scala b/common/src/main/scala/net/psforever/packet/game/PlanetsideAttributeMessage.scala
index eec5c312..ac4b49ff 100644
--- a/common/src/main/scala/net/psforever/packet/game/PlanetsideAttributeMessage.scala
+++ b/common/src/main/scala/net/psforever/packet/game/PlanetsideAttributeMessage.scala
@@ -118,7 +118,10 @@ import scodec.codecs._
   * `27 - PA_JAMMED - plays jammed buzzing sound`<br>
   * `28 - PA_IMPLANT_ACTIVE - Plays implant sounds. Valid values seem to be up to 20.`<br>
   * `29 - PA_VAPORIZED - Visible ?! That's not the cloaked effect, Maybe for spectator mode ?. Value is 0 to visible, 1 to invisible.`<br>
-  * `31 - Info under avatar name : 0 = LFS, 1 = Looking For Squad Members`<br>
+  * `31 - Looking for Squad info (marquee and ui):<br>
+  * ` - 0 is LFS`<br>
+  * ` - 1 is LFSM (Looking for Squad Members)`<br>
+  * ` - n is the supplemental squad identifier number; same as "LFS;" for the leader, sets "LFSM" after the first manual flagging`<br>
   * `32 - Info under avatar name : 0 = Looking For Squad Members, 1 = LFS`<br>
   * `35 - BR. Value is the BR`<br>
   * `36 - CR. Value is the CR`<br>
diff --git a/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala b/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala
index 6fd99e69..eab055a9 100644
--- a/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala
+++ b/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala
@@ -360,6 +360,7 @@ object SquadAction{
   * &nbsp;&nbsp;&nbsp;&nbsp;`17` - Set List Squad (ui)<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`18` - UNKNOWN<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`26` - Reset All<br>
+  * &nbsp;&nbsp;&nbsp;&nbsp;`32` - UNKNOWN<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`35` - Cancel Squad Search<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`39` - No Squad Search Results<br>
   * &nbsp;&nbsp;&nbsp;&nbsp;`41` - Cancel Find<br>
diff --git a/common/src/main/scala/services/teamwork/SquadAction.scala b/common/src/main/scala/services/teamwork/SquadAction.scala
index 5b3ed90e..a0034da5 100644
--- a/common/src/main/scala/services/teamwork/SquadAction.scala
+++ b/common/src/main/scala/services/teamwork/SquadAction.scala
@@ -3,11 +3,14 @@ package services.teamwork
 
 import net.psforever.objects.zones.Zone
 import net.psforever.packet.game._
-import net.psforever.types.{SquadRequestType, Vector3}
+import net.psforever.types.{PlanetSideEmpire, SquadRequestType, Vector3}
 
 object SquadAction {
   trait Action
 
+  final case class InitSquadList() extends Action
+  final case class InitCharId() extends Action
+
   final case class Definition(guid : PlanetSideGUID, line : Int, action : SquadAction) extends Action
   final case class Membership(request_type : SquadRequestType.Value, unk2 : Long, unk3 : Option[Long], player_name : String, unk5 : Option[Option[String]]) extends Action
   final case class Waypoint(event_type : WaypointEventAction.Value, waypoint_type : Int, unk : Option[Long], waypoint_info : Option[WaypointInfo]) extends Action
diff --git a/common/src/main/scala/services/teamwork/SquadResponse.scala b/common/src/main/scala/services/teamwork/SquadResponse.scala
index 817d27e5..5860145c 100644
--- a/common/src/main/scala/services/teamwork/SquadResponse.scala
+++ b/common/src/main/scala/services/teamwork/SquadResponse.scala
@@ -20,8 +20,8 @@ object SquadResponse {
 
   final case class Membership(request_type : SquadResponseType.Value, unk1 : Int, unk2 : Int, unk3 : Long, unk4 : Option[Long], player_name : String, unk5 : Boolean, unk6 : Option[Option[String]]) extends Response //see SquadMembershipResponse
   final case class Invite(from_char_id : Long, to_char_id : Long, name : String) extends Response
-  final case class WantsSquadPosition(bid_name : String) extends Response
-  final case class Join(squad : Squad, positionsToUpdate : List[Int]) extends Response
+  final case class WantsSquadPosition(leader_char_id : Long, bid_name : String) extends Response
+  final case class Join(squad : Squad, positionsToUpdate : List[Int], channel : String) extends Response
   final case class Leave(squad : Squad, positionsToUpdate : List[(Long, Int)]) extends Response
   final case class UpdateMembers(squad : Squad, update_info : List[SquadAction.Update]) extends Response
   final case class AssignMember(squad : Squad, from_index : Int, to_index : Int) extends Response
diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index 2c22886c..b837e7a1 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -1,11 +1,11 @@
 // Copyright (c) 2019 PSForever
 package services.teamwork
 
-import akka.actor.{Actor, ActorContext, ActorRef, Props}
-import net.psforever.objects.Player
+import akka.actor.{Actor, ActorRef, Terminated}
+import net.psforever.objects.{Avatar, LivePlayerList, Player}
 import net.psforever.objects.definition.converter.StatConverter
 import net.psforever.objects.loadouts.SquadLoadout
-import net.psforever.objects.teamwork.{Member, Squad}
+import net.psforever.objects.teamwork.{Member, Squad, SquadFeatures}
 import net.psforever.objects.zones.Zone
 import net.psforever.packet.game._
 import net.psforever.types._
@@ -15,8 +15,6 @@ import scala.collection.concurrent.TrieMap
 import scala.collection.mutable
 import scala.collection.mutable.ListBuffer
 
-//import scala.concurrent.duration._
-
 class SquadService extends Actor {
   import SquadService._
 
@@ -26,31 +24,120 @@ class SquadService extends Actor {
     * A squad of `PlanetSideGUID(0)` indicates both a nonexistent squad and the default no-squad for clients.
     */
   private var sid : Int = 1
-
-  private var memberToSquad : mutable.LongMap[Squad] = mutable.LongMap[Squad]()
-  private val invites : mutable.LongMap[Invitation] = mutable.LongMap[Invitation]()
-  private val queuedInvites : mutable.LongMap[List[Invitation]] = mutable.LongMap[List[Invitation]]()
   /**
-    * A placeholder for an absent active invite that has not (yet) been accepted or rejected, equal to the then-current active invite.
-    * Created when removing an active invite.
-    * Checked when trying to add a new invite (if found, the invite is queued).
-    * Cleared when the next queued invite becomes active.
+    * All squads.<br>
+    * key - squad unique number; value - the squad wrapped around its attributes object
     */
-  private val previousInvites : mutable.LongMap[Invitation] = mutable.LongMap[Invitation]()
-
-  private var squadFeatures : TrieMap[PlanetSideGUID, SquadService.SquadFeatures] = new TrieMap[PlanetSideGUID, SquadService.SquadFeatures]()
-  private val publishedLists : TrieMap[PlanetSideEmpire.Value, ListBuffer[SquadInfo]] = TrieMap[PlanetSideEmpire.Value, ListBuffer[SquadInfo]](
+  private var squadFeatures : TrieMap[PlanetSideGUID, SquadFeatures] = new TrieMap[PlanetSideGUID, SquadFeatures]()
+  /**
+    * The list of squads that each of the factions see for the purposes of keeping track of changes to the list.
+    * These squads are considered public "listed" squads -
+    * all the players of a certain faction can see them in the squad list
+    * and may have limited interaction with their squad definition windows.<br>
+    * key - squad unique number; value - the squad's unique identifier number
+    */
+  private val publishedLists : TrieMap[PlanetSideEmpire.Value, ListBuffer[PlanetSideGUID]] = TrieMap[PlanetSideEmpire.Value, ListBuffer[PlanetSideGUID]](
     PlanetSideEmpire.TR -> ListBuffer.empty,
     PlanetSideEmpire.NC -> ListBuffer.empty,
     PlanetSideEmpire.VS -> ListBuffer.empty
   )
 
+  /**
+    * key - a unique character identifier number; value - the squad to which this player is a member
+    */
+  private var memberToSquad : mutable.LongMap[Squad] = mutable.LongMap[Squad]()
+  /**
+    * key - a unique character identifier number; value - the active invitation object
+    */
+  private val invites : mutable.LongMap[Invitation] = mutable.LongMap[Invitation]()
+  /**
+    * key - a unique character identifier number; value - a list of inactive invitation objects waiting to be resolved
+    */
+  private val queuedInvites : mutable.LongMap[List[Invitation]] = mutable.LongMap[List[Invitation]]()
+  /**
+    * The gien player has refused participation into this other player's sqaud.<br>
+    * key - a unique character identifier number; value - a list of unique character identifier numbers
+    */
+  private val refused : mutable.LongMap[List[Long]] = mutable.LongMap[List[Long]]()
+  /**
+    * Players who are interested in updated details regarding a certain squad though they may not be a member of the squad.<br>
+    * key - unique character identifier number; value - a squad identifier number
+    */
+  private val continueToMonitorDetails : mutable.LongMap[PlanetSideGUID] = mutable.LongMap[PlanetSideGUID]()
+  /**
+    * A placeholder for an absent active invite that has not (yet) been accepted or rejected, equal to the then-current active invite.
+    * Created when removing an active invite.
+    * Checked when trying to add a new invite (if found, the invite is queued).
+    * Cleared when the next queued invite becomes active.<br>
+    * key - unique character identifier number; value, unique character identifier number
+    */
+  private val previousInvites : mutable.LongMap[Invitation] = mutable.LongMap[Invitation]()
+
+  /**
+    * This is a formal `ActorEventBus` object that is reserved for faction-wide messages and squad-specific messages.
+    * When the user joins the `SquadService` with a `Service.Join` message
+    * that includes a confirmed faction affiliation identifier,
+    * the origin `ActorRef` is added as a subscription.
+    * Squad channels are produced when a squad is created,
+    * and are subscribed to as users join the squad,
+    * and unsubscribed from as users leave the squad.<br>
+    * key - a `PlanetSideEmpire` value; value - `ActorRef` reference<br>
+    * key - a consistent squad channel name; value - `ActorRef` reference
+    * @see `CloseSquad`
+    * @see `JoinSquad`
+    * @see `LeaveSquad`
+    * @see `Service.Join`
+    * @see `Service.Leave`
+    */
+  private val SquadEvents = new GenericEventBus[SquadServiceResponse]
+  /**
+    * This collection contains the message-sending contact reference for individuals who may become squad members.
+    * When the user joins the `SquadService` with a `Service.Join` message
+    * that includes their unique character identifier,
+    * the origin `ActorRef` is added as a subscription.
+    * It is maintained until they disconnect entirely.
+    * The subscription is anticipated to belong to an instance of `WorldSessionActor`.<br>
+    * key - unique character identifier number; value - `ActorRef` reference for that character
+    * @see `Service.Join`
+    */
+  private val UserEvents : mutable.LongMap[ActorRef] = mutable.LongMap[ActorRef]()
+
   private [this] val log = org.log4s.getLogger
+  
+  private def debug(msg : String) : Unit = {
+    log.info(msg)
+  }
 
   override def preStart : Unit = {
     log.info("Starting...")
   }
 
+  override def postStop() : Unit = {
+    //invitations
+    invites.clear()
+    queuedInvites.clear()
+    previousInvites.clear()
+    refused.clear()
+    continueToMonitorDetails.clear()
+    //squads and members (users)
+    squadFeatures.foreach { case(_, features) =>
+      CloseSquad(features.Squad)
+    }
+    memberToSquad.clear()
+    publishedLists.clear()
+    UserEvents.foreach { case(_, actor) =>
+      SquadEvents.unsubscribe(actor)
+    }
+    UserEvents.clear()
+  }
+
+  /**
+    * Produce the next available unique squad identifier.
+    * The first number is always 1.
+    * The greatest possible identifier is 65535 (an unsigned 16-bit integer)
+    * before it wraps back around to 1.
+    * @return the current squad unique identifier number
+    */
   def GetNextSquadId() : PlanetSideGUID = {
     val out = sid
     val j = sid + 1
@@ -63,6 +150,10 @@ class SquadService extends Actor {
     PlanetSideGUID(out)
   }
 
+  /**
+    * Set the unique squad identifier back to the start (1) if no squads are active.
+    * @return `true`, if the identifier is reset; `false`, otherwise
+    */
   def TryResetSquadId() : Boolean = {
     if(squadFeatures.isEmpty) {
       sid = 1
